/*
* Petit Station
*
* Created: 2020/4/29
* Author : TRAINO
*
*  Pin Assignment 
*    (OC0A)(TPID)PB0 1   6 PB3(RST)
*                GND 2   5 Vcc
*    (OC0B)(TPIC)PB1 3   4 PB2   
*
*  PB0 = ADC
*  PB1 = OUTA(OUT1)
*  PB2 = OUTB(OUT2)
* 
* Ver 0
*   VR3の端子を浮かさないと、ISP書込みできない。（PB0 MISO）=>3時のいちならOK
*   アドレス変更すると、センターに戻さずに出力がでる
*/
#define ThresholdOfBlueButton 249
#include <avr/io.h>
#define cbi(addr,bit)     addr &= ~(1<<bit) // cbi()    addrのbit番目をLowに
#define sbi(addr,bit)     addr |=  (1<<bit) // sbi()    addrのbit番目をHighに
#define sigIsHigh bit_is_set(PINB,PINB2)
#define sigIsLow bit_is_clear(PINB,PINB2)
/*
** mS単位のウエイト関数
*/
void wait_ms(short time) {
  for(;time!=0;time--) for(short j=0;j<200;j++) cbi(PORTB,PINB3); // 500mSチューニング済
}
void wait_58usH() {  //hiの長さ
   for(short j=0;j<9;j++) cbi(PORTB,PINB3);
}
void wait_58usL() {  //loの長さ
   for(short j=0;j<10;j++) cbi(PORTB,PINB3); 
} 
#define wait_110us() {wait_58usL();wait_58usL();}
//
// ADC
//
unsigned char adconv(){
  cbi(ADCSRA,ADIF);                        //変換完了フラグをリセット
  sbi(ADCSRA,ADSC);                       //変換開始。ADSC(A/D変換開始レジスタ)
  loop_until_bit_is_set(ADCSRA,ADIF);      //変換完了フラグが1になるまで待機
  return (unsigned char)ADCL;              //ad_dataにデータの上位8ビットを格納
}
//
//
// 連続した１の送信（最後は0)
//
void sendPriamble(signed count) {
  do {
    sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;
  } while (--count >=0);
  // send zero
  sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH() ;wait_58usH() ;
  cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usH() ;wait_58usL() ;
}
void sendzero(signed count) {
  do {
    sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH() ;wait_58usH() ;
    cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usH() ;wait_58usL() ;
  } while (--count >=0);
}
void sendData(unsigned char a,unsigned char last) {
  if(a&0x80) {   sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else 
  { sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH() ;wait_58usH() ;
    cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usH() ;wait_58usL() ;
  }
  if(a&0x40) {   sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else {  sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH() ;wait_58usH() ;cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usH() ;wait_58usL() ;  }
  if(a&0x20) {    sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ; }
  else {  sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH() ;wait_58usH() ;cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usH() ;wait_58usL() ;  }
  if(a&0x10) {   sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else {  sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH() ;wait_58usH() ;cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usH() ;wait_58usL() ;  }
  if(a&0x8) {    sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else {  sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH() ;wait_58usH() ;cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usH() ;wait_58usL() ;  }
  if(a&0x4) {    sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else {  sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH() ;wait_58usH() ;cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usH() ;wait_58usL() ;  }
  if(a&0x2) {    sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else {  sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH() ;wait_58usH() ;cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usH() ;wait_58usL() ;  }
  if(a&0x1) {    sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;  }
  else {  sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH() ;wait_58usH() ;cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usH() ;wait_58usL() ;  }
  // last zero  
  if(last!=0) {    sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH(); cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usL()  ;}
  // zero
  sbi(PORTB,PORTB1);cbi(PORTB,PORTB2);wait_58usH() ;wait_58usH() ;cbi(PORTB,PORTB1);sbi(PORTB,PORTB2);wait_58usH() ;wait_58usL() ;
}
//
// 
//
void funcControl(unsigned char adrs,unsigned char cmd) {
  sendPriamble(14);  // 1,1,1,1,1,1,1,1,,,,0
  sendData(adrs,0);    // adrs1 == 03 -> 0000 0011 & 0
  sendData(cmd,0);    // 0x80
  sendData(adrs^cmd,1); //
  sendzero(14);
}
void sendLEDON() { 
  PORTB = 0B00000110;
  wait_ms(100);
}
void sendLEDOFF() {
  PORTB = 0B00000000;
  wait_ms(100);
}
unsigned char getadrs() {  // 長押しで入ってくる
  unsigned char num,numold=0,dispnum=0;
  for(;adconv()>ThresholdOfBlueButton;) sendLEDON(); // 長押しで待つ 
  for(;;) {
    sendLEDOFF(); // 消灯
    num = adconv(); //まずはAD結果をとる
    // 0 bluebutton? 
    if (num>ThresholdOfBlueButton) {
      sendLEDON();
      wait_ms(500);
      return numold;
    }
    // convert the angle to num
    if(num < 19) num = 0;
    else num = (num-19)/22;
    //if(num>9) num=9;
    //numold = num;

    if(num<=9) numold = num; 
    if(++dispnum <= numold) {
        sendLEDON();
        if(dispnum+4 <= numold) { // ５はLED点灯を長くする。
        sendLEDON();
        sendLEDON();
        dispnum+=4;  
        }
    }
    else {
        sendLEDOFF();
        dispnum = 0;    
    }
    sendLEDOFF();
  }
}

int main(void) {
  unsigned char address=3,cmd3=0x80,lastad=0x80,ad_data; 
  DDRB= 0B00000110;   // PB0 = volume ,PB1,PB2=output port
  DIDR0 = 0B01;   //  disable digital input for AD conversion
  ADCSRA= 0b10000111; // permit AD conv, clock = 1/128 clock
  // ADMUX =0;      // MUX = B0 (default setting)

  // wait Blue button
  wait_ms(100);
  for(;adconv()<ThresholdOfBlueButton;);

  for(unsigned char cc=0;;cc++) {
    if(adconv()<ThresholdOfBlueButton) break;  //短め押しなら、すぐ次へ
    if(cc>200) { // タイマー
      address=getadrs()*10+getadrs(); //2桁アドレスゲット
      sendLEDOFF();
      for(;adconv()>ThresholdOfBlueButton;);  
      for(;adconv()<ThresholdOfBlueButton;);
      break; // getアドレスで通電開始、ボタンを離したらOFFにする
    } //長押しなら２桁入力へ
    wait_ms(5);
  }

  // ボリュームがセンターに戻るのを待って出力を始める
  for(;adconv()<0x70;); 
  for(;adconv()>0x90;);
  //
  // DCC 出力
  //  
  for(;;) {
    funcControl(address,0B10010001); // 0b100ddddd ,F1 on F2 = off
    ad_data = adconv();
    if(ad_data>=ThresholdOfBlueButton) { // ボタンが押されたら、離されるまでずっとF2オンを流す
      for(;ad_data>=ThresholdOfBlueButton ; ad_data = adconv()) {
        funcControl(address,0B10010011); // 0b100ddddd F2 = on
        //speedControl(address,lastad);
        // ad_data = adconv();
      } // while (ad_data>=ThresholdOfBlueButton);
    }
    else
      lastad=ad_data;
    // set speedstep
    cmd3 = lastad & 0x80;
    if(lastad>0x90) cmd3 = lastad - 0x90 + 0x80; // FWD
    if(lastad<0x70) cmd3 = 0x70 - lastad;  //BACK
    if((cmd3 & 0x7f)==0x01) cmd3 &= 0xFE; // speed step 1 is emergency stop => forced 0
    
    // send speed control
    sendPriamble(14); // 1,1,1,1,1,1,1,1,,,,0
    sendData(address,0); // adrs1 == 03 -> 0000 0011 & 0
    sendData(0x3F,0); // 3F  = 128 step
    sendData(cmd3,0); // 0x80
    sendData(address^0x3f^cmd3,1);  //  send ex-or checksum
    sendzero(14);
  }
}
// End of file
